GDAL

- Main Page
- Related Pages
- Classes
- Files

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions | Protected Attributes | Friends | List of all members
OGRSimpleCurve Class Reference

Abstract curve base class for OGRLineString and OGRCircularString. More...

`#include <ogr_geometry.h>`

Inheritance diagram for OGRSimpleCurve:

## Public Member Functions
OGRSimpleCurve & | operator= (const OGRSimpleCurve &other)
| Assignment operator. More...
virtual int | WkbSize () const
| Returns size of related binary representation. More...
virtual OGRErr | importFromWkb (unsigned char *, int=-1, OGRwkbVariant=wkbVariantOldOgc)
| Assign geometry from well known binary data. More...
virtual OGRErr | exportToWkb (OGRwkbByteOrder, unsigned char *, OGRwkbVariant=wkbVariantOldOgc) const
| Convert a geometry into well known binary format. More...
virtual OGRErr | importFromWkt (char **)
| Assign geometry from well known text data. More...
virtual OGRErr | exportToWkt (char **ppszDstText, OGRwkbVariant=wkbVariantOldOgc) const
| Convert a geometry into well known text format. More...
virtual OGRGeometry * | clone () const
| Make a copy of this object. More...
virtual void | empty ()
| Clear geometry information. More...
virtual void | getEnvelope (OGREnvelope *psEnvelope) const
| Computes and returns the bounding envelope for this geometry in the passed psEnvelope structure. More...
virtual void | getEnvelope (OGREnvelope3D *psEnvelope) const
| Computes and returns the bounding envelope (3D) for this geometry in the passed psEnvelope structure. More...
virtual OGRBoolean | IsEmpty () const
| Returns TRUE (non-zero) if the object has no points. More...
virtual double | get_Length () const
| Returns the length of the curve. More...
virtual void | StartPoint (OGRPoint *) const
| Return the curve start point. More...
virtual void | EndPoint (OGRPoint *) const
| Return the curve end point. More...
virtual void | Value (double, OGRPoint *) const
| Fetch point at given distance along curve. More...
virtual double | Project (const OGRPoint *) const
| Project point on linestring. More...
virtual OGRLineString * | getSubLine (double, double, int) const
| Get the portion of linestring. More...
virtual int | getNumPoints () const
| Fetch vertex count. More...
void | getPoint (int, OGRPoint *) const
| Fetch a point in line string. More...
double | getX (int i) const
| Get X at vertex. More...
double | getY (int i) const
| Get Y at vertex. More...
double | getZ (int i) const
| Get Z at vertex. More...
double | getM (int i) const
| Get measure at vertex. More...
virtual OGRBoolean | Equals (OGRGeometry *) const
| Returns TRUE if two geometries are equivalent. More...
virtual void | setCoordinateDimension (int nDimension)
| Set the coordinate dimension. More...
virtual void | set3D (OGRBoolean bIs3D)
| Add or remove the Z coordinate dimension. More...
virtual void | setMeasured (OGRBoolean bIsMeasured)
| Add or remove the M coordinate dimension. More...
void | setNumPoints (int nNewPointCount, int bZeroizeNewContent=TRUE)
| Set number of points in geometry. More...
void | setPoint (int, OGRPoint *)
| Set the location of a vertex in line string. More...
void | setPoint (int, double, double)
void | setZ (int, double)
void | setM (int, double)
void | setPoint (int, double, double, double)
| Set the location of a vertex in line string. More...
void | setPointM (int, double, double, double)
void | setPoint (int, double, double, double, double)
void | setPoints (int, OGRRawPoint *, double *=NULL)
| Assign all points in a line string. More...
void | setPointsM (int, OGRRawPoint *, double *)
| Assign all points in a line string. More...
void | setPoints (int, OGRRawPoint *, double *, double *)
| Assign all points in a line string. More...
void | setPoints (int, double *padfX, double *padfY, double *padfZIn=NULL)
| Assign all points in a line string. More...
void | setPointsM (int, double *padfX, double *padfY, double *padfMIn=NULL)
| Assign all points in a line string. More...
void | setPoints (int, double *padfX, double *padfY, double *padfZIn, double *padfMIn)
| Assign all points in a line string. More...
void | addPoint (OGRPoint *)
| Add a point to a line string. More...
void | addPoint (double, double)
void | addPoint (double, double, double)
void | addPointM (double, double, double)
| Add a point to a line string. More...
void | addPoint (double, double, double, double)
| Add a point to a line string. More...
void | getPoints (OGRRawPoint *, double *=NULL) const
| Returns all points of line string. More...
void | getPoints (OGRRawPoint *, double *, double *) const
void | getPoints (void *pabyX, int nXStride, void *pabyY, int nYStride, void *pabyZ=NULL, int nZStride=0) const
| Returns all points of line string. More...
void | getPoints (void *pabyX, int nXStride, void *pabyY, int nYStride, void *pabyZ, int nZStride, void *pabyM, int nMStride) const
void | addSubLineString (const OGRLineString *, int nStartVertex=0, int nEndVertex=-1)
| Add a segment of another linestring to this one. More...
void | reversePoints (void)
| Reverse point order. More...
virtual OGRPointIterator * | getPointIterator () const
| Returns a point iterator over the curve. More...
virtual OGRErr | transform (OGRCoordinateTransformation *poCT)
| Apply arbitrary coordinate transformation to geometry. More...
virtual void | flattenTo2D ()
| Convert geometry to strictly 2D. More...
virtual void | segmentize (double dfMaxLength)
| Modify the geometry such it has no segment longer then the given distance. More...
virtual void | swapXY ()
| Swap x and y coordinates. More...
Public Member Functions inherited from OGRCurve
OGRCurve & | operator= (const OGRCurve &other)
virtual int | get_IsClosed () const
| Return TRUE if curve is closed. More...
virtual OGRLineString * | CurveToLine (double dfMaxAngleStepSizeDegrees=0, const char *const *papszOptions=NULL) const =0
| Return a linestring from a curve geometry. More...
virtual int | getDimension () const
| Get the dimension of this object. More...
virtual OGRBoolean | IsConvex () const
| Returns if a (closed) curve forms a convex shape. More...
virtual double | get_Area () const =0
| Get the area of the (closed) curve. More...
Public Member Functions inherited from OGRGeometry
| OGRGeometry (const OGRGeometry &other)
| Copy constructor. More...
OGRGeometry & | operator= (const OGRGeometry &other)
| Assignment operator. More...
virtual int | getCoordinateDimension () const
| Get the dimension of the coordinates in this object. More...
int | CoordinateDimension () const
| Get the dimension of the coordinates in this object. More...
virtual OGRBoolean | IsValid () const
| Test if the geometry is valid. More...
virtual OGRBoolean | IsSimple () const
| Test if the geometry is simple. More...
OGRBoolean | Is3D () const
OGRBoolean | IsMeasured () const
virtual OGRBoolean | IsRing () const
| Test if the geometry is a ring. More...
virtual OGRwkbGeometryType | getGeometryType () const =0
| Fetch geometry type. More...
OGRwkbGeometryType | getIsoGeometryType () const
| Get the geometry type that conforms with ISO SQL/MM Part3. More...
virtual const char * | getGeometryName () const =0
| Fetch WKT name for geometry type. More...
virtual void | dumpReadable (FILE *, const char *=NULL, char **papszOptions=NULL) const
| Dump geometry in well known text format to indicated output file. More...
virtual char * | exportToGML (const char *const *papszOptions=NULL) const
| Convert a geometry into GML format. More...
virtual char * | exportToKML () const
| Convert a geometry into KML format. More...
virtual char * | exportToJson () const
| Convert a geometry into GeoJSON format. More...
virtual GEOSGeom | exportToGEOS (GEOSContextHandle_t hGEOSCtxt) const CPL_WARN_UNUSED_RESULT
virtual OGRBoolean | hasCurveGeometry (int bLookForNonLinear=FALSE) const
| Returns if this geometry is or has curve geometry. More...
virtual OGRGeometry * | getCurveGeometry (const char *const *papszOptions=NULL) const CPL_WARN_UNUSED_RESULT
| Return curve version of this geometry. More...
virtual OGRGeometry * | getLinearGeometry (double dfMaxAngleStepSizeDegrees=0, const char *const *papszOptions=NULL) const CPL_WARN_UNUSED_RESULT
| Return, possibly approximate, non-curve version of this geometry. More...
virtual void | closeRings ()
| Force rings to be closed. More...
void | assignSpatialReference (OGRSpatialReference *poSR)
| Assign spatial reference to this object. More...
OGRSpatialReference * | getSpatialReference (void) const
| Returns spatial reference system for object. More...
OGRErr | transformTo (OGRSpatialReference *poSR)
| Transform geometry to new spatial reference system. More...
virtual OGRBoolean | Intersects (const OGRGeometry *) const
| Do these features intersect? More...
virtual OGRBoolean | Disjoint (const OGRGeometry *) const
| Test for disjointness. More...
virtual OGRBoolean | Touches (const OGRGeometry *) const
| Test for touching. More...
virtual OGRBoolean | Crosses (const OGRGeometry *) const
| Test for crossing. More...
virtual OGRBoolean | Within (const OGRGeometry *) const
| Test for containment. More...
virtual OGRBoolean | Contains (const OGRGeometry *) const
| Test for containment. More...
virtual OGRBoolean | Overlaps (const OGRGeometry *) const
| Test for overlap. More...
virtual OGRGeometry * | Boundary () const CPL_WARN_UNUSED_RESULT
| Compute boundary. More...
virtual double | Distance (const OGRGeometry *) const
| Compute distance between two geometries. More...
virtual OGRGeometry * | ConvexHull () const CPL_WARN_UNUSED_RESULT
| Compute convex hull. More...
virtual OGRGeometry * | Buffer (double dfDist, int nQuadSegs=30) const CPL_WARN_UNUSED_RESULT
| Compute buffer of geometry. More...
virtual OGRGeometry * | Intersection (const OGRGeometry *) const CPL_WARN_UNUSED_RESULT
| Compute intersection. More...
virtual OGRGeometry * | Union (const OGRGeometry *) const CPL_WARN_UNUSED_RESULT
| Compute union. More...
virtual OGRGeometry * | UnionCascaded () const CPL_WARN_UNUSED_RESULT
| Compute union using cascading. More...
virtual OGRGeometry * | Difference (const OGRGeometry *) const CPL_WARN_UNUSED_RESULT
| Compute difference. More...
virtual OGRGeometry * | SymDifference (const OGRGeometry *) const CPL_WARN_UNUSED_RESULT
| Compute symmetric difference. More...
virtual OGRErr | Centroid (OGRPoint *poPoint) const
| Compute the geometry centroid. More...
virtual OGRGeometry * | Simplify (double dTolerance) const CPL_WARN_UNUSED_RESULT
| Simplify the geometry. More...
OGRGeometry * | SimplifyPreserveTopology (double dTolerance) const CPL_WARN_UNUSED_RESULT
| Simplify the geometry while preserving topology. More...
virtual OGRGeometry * | DelaunayTriangulation (double dfTolerance, int bOnlyEdges) const CPL_WARN_UNUSED_RESULT
| Return a Delaunay triangulation of the vertices of the geometry. More...
virtual OGRGeometry * | Polygonize () const CPL_WARN_UNUSED_RESULT
| Polygonizes a set of sparse edges. More...
OGRBoolean | Intersect (OGRGeometry *) const CPL_WARN_DEPRECATED("Non standard method. Use Intersects() instead")
OGRBoolean | Equal (OGRGeometry *) const CPL_WARN_DEPRECATED("Non standard method. Use Equals() instead")
OGRGeometry * | SymmetricDifference (const OGRGeometry *) const CPL_WARN_DEPRECATED("Non standard method. Use SymDifference() instead")
| Compute symmetric difference (deprecated) More...
OGRGeometry * | getBoundary () const CPL_WARN_DEPRECATED("Non standard method. Use Boundary() instead")
| Compute boundary (deprecated) More...

## Protected Member Functions
void | Make3D ()
void | Make2D ()
void | RemoveM ()
void | AddM ()
OGRErr | importFromWKTListOnly (char **ppszInput, int bHasZ, int bHasM, OGRRawPoint *&paoPointsIn, int &nMaxPoints, double *&padfZIn)
virtual double | get_LinearArea () const
| Compute area of ring / closed linestring. More...
| OGRSimpleCurve (const OGRSimpleCurve &other)
| Copy constructor. More...
Protected Member Functions inherited from OGRCurve
| OGRCurve (const OGRCurve &other)
virtual OGRCurveCasterToLineString | GetCasterToLineString () const =0
virtual OGRCurveCasterToLinearRing | GetCasterToLinearRing () const =0
virtual int | ContainsPoint (const OGRPoint *p) const
| Returns if a point is contained in a (closed) curve. More...
virtual double | get_AreaOfCurveSegments () const =0
| Get the area of the purely curve portions of a (closed) curve. More...
Protected Member Functions inherited from OGRGeometry
OGRErr | importPreambuleFromWkt (char **ppszInput, int *pbHasZ, int *pbHasM, bool *pbIsEmpty)
OGRErr | importCurveCollectionFromWkt (char **ppszInput, int bAllowEmptyComponent, int bAllowLineString, int bAllowCurve, int bAllowCompoundCurve, OGRErr(*pfnAddCurveDirectly)(OGRGeometry *poSelf, OGRCurve *poCurve))
OGRErr | importPreambuleFromWkb (unsigned char *pabyData, int nSize, OGRwkbByteOrder &eByteOrder, OGRwkbVariant eWkbVariant)
OGRErr | importPreambuleOfCollectionFromWkb (unsigned char *pabyData, int &nSize, int &nDataOffset, OGRwkbByteOrder &eByteOrder, int nMinSubGeomSize, int &nGeomCount, OGRwkbVariant eWkbVariant)
OGRErr | PointOnSurfaceInternal (OGRPoint *poPoint) const

## Protected Attributes
int | nPointCount
OGRRawPoint * | paoPoints
double * | padfZ
double * | padfM
Protected Attributes inherited from OGRGeometry
unsigned int | flags

## Friends
class | OGRGeometry

## Additional Inherited Members
Static Public Member Functions inherited from OGRCurve
static OGRCompoundCurve * | CastToCompoundCurve (OGRCurve *puCurve)
| Cast to compound curve. More...
static OGRLineString * | CastToLineString (OGRCurve *poCurve)
| Cast to linestring. More...
static OGRLinearRing * | CastToLinearRing (OGRCurve *poCurve)
| Cast to linear ring. More...
Static Public Member Functions inherited from OGRGeometry
static GEOSContextHandle_t | createGEOSContext ()
static void | freeGEOSContext (GEOSContextHandle_t hGEOSCtxt)
static OGRGeometry * | CastToIdentity (OGRGeometry *poGeom)
static OGRGeometry * | CastToError (OGRGeometry *poGeom)
Static Public Attributes inherited from OGRGeometry
static const unsigned int | OGR_G_NOT_EMPTY_POINT = 0x1
static const unsigned int | OGR_G_3D = 0x2
static const unsigned int | OGR_G_MEASURED = 0x4
static int | bGenerate_DB2_V72_BYTE_ORDER = FALSE

## Detailed Description

Abstract curve base class for OGRLineString and OGRCircularString.

Note: this class does not exist in SQL/MM standard and exists for implementation convenience.

Since
  GDAL 2.0

## Constructor & Destructor Documentation

OGRSimpleCurve::OGRSimpleCurve | ( | const OGRSimpleCurve & | other | ) |
| protected

Copy constructor.

Note: before GDAL 2.1, only the default implementation of the constructor existed, which could be unsafe to use.

Since
  GDAL 2.1

## Member Function Documentation

void OGRSimpleCurve::addPoint | ( | OGRPoint * | poPoint | ) |

Add a point to a line string.

The vertex count of the line string is increased by one, and assigned from the passed location value.

There is no SFCOM analog to this method.

Parameters

  poPoint | the point to assign to the new vertex.

void OGRSimpleCurve::addPoint | ( | double | x,
|  | double | y,
|  | double | z,
|  | double | m
| ) |  |

Add a point to a line string.

The vertex count of the line string is increased by one, and assigned from the passed location value.

There is no SFCOM analog to this method.

Parameters

  x | the X coordinate to assign to the new point.
  y | the Y coordinate to assign to the new point.
  z | the Z coordinate to assign to the new point (defaults to zero).

void OGRSimpleCurve::addPointM | ( | double | x,
|  | double | y,
|  | double | m
| ) |  |

Add a point to a line string.

The vertex count of the line string is increased by one, and assigned from the passed location value.

There is no SFCOM analog to this method.

Parameters

  x | the X coordinate to assign to the new point.
  y | the Y coordinate to assign to the new point.
  m | the M coordinate to assign to the new point.

void OGRSimpleCurve::addSubLineString | ( | const OGRLineString * | poOtherLine,
|  | int | nStartVertex = `0`,
|  | int | nEndVertex = `-1`
| ) |  |

Add a segment of another linestring to this one.

Adds the request range of vertices to the end of this line string in an efficient manner. If the nStartVertex is larger than the nEndVertex then the vertices will be reversed as they are copied.

Parameters

  poOtherLine | the other OGRLineString.
  nStartVertex | the first vertex to copy, defaults to 0 to start with the first vertex in the other linestring.
  nEndVertex | the last vertex to copy, defaults to -1 indicating the last vertex of the other line string.

OGRGeometry * OGRSimpleCurve::clone | ( |  | ) | const
| virtual

Make a copy of this object.

This method relates to the SFCOM IGeometry::clone() method.

This method is the same as the C function OGR_G_Clone().

Returns
  a new object instance with the same geometry, and spatial reference system as the original.

Implements OGRGeometry.

Reimplemented in OGRLinearRing.

void OGRSimpleCurve::empty | ( |  | ) |
| virtual

Clear geometry information.

This restores the geometry to it's initial state after construction, and before assignment of actual geometry.

This method relates to the SFCOM IGeometry::Empty() method.

This method is the same as the C function OGR_G_Empty().

Implements OGRGeometry.

void OGRSimpleCurve::EndPoint | ( | OGRPoint * | poPoint | ) | const
| virtual

Return the curve end point.

This method relates to the SF COM ICurve::get_EndPoint() method.

Parameters

  poPoint | the point to be assigned the end location.

Implements OGRCurve.

OGRBoolean OGRSimpleCurve::Equals | ( | OGRGeometry * | poOtherGeom | ) | const
| virtual

Returns TRUE if two geometries are equivalent.

This method is the same as the C function OGR_G_Equals().

Returns
  TRUE if equivalent or FALSE otherwise.

Implements OGRGeometry.

OGRErr OGRSimpleCurve::exportToWkb | ( | OGRwkbByteOrder | eByteOrder,
|  | unsigned char * | pabyData,
|  | OGRwkbVariant | eWkbVariant = `wkbVariantOldOgc`
| ) |  | const
| virtual

Convert a geometry into well known binary format.

This method relates to the SFCOM IWks::ExportToWKB() method.

This method is the same as the C function OGR_G_ExportToWkb() or OGR_G_ExportToIsoWkb(), depending on the value of eWkbVariant.

Parameters

  eByteOrder | One of wkbXDR or wkbNDR indicating MSB or LSB byte order respectively.
  pabyData | a buffer into which the binary representation is written. This buffer must be at least OGRGeometry::WkbSize() byte in size.
  eWkbVariant | What standard to use when exporting geometries with three dimensions (or more). The default wkbVariantOldOgc is the historical OGR variant. wkbVariantIso is the variant defined in ISO SQL/MM and adopted by OGC for SFSQL 1.2.

Returns
  Currently OGRERR_NONE is always returned.

Implements OGRGeometry.

Reimplemented in OGRCircularString, and OGRLinearRing.

OGRErr OGRSimpleCurve::exportToWkt | ( | char ** | ppszDstText,
|  | OGRwkbVariant | eWkbVariant = `wkbVariantOldOgc`
| ) |  | const
| virtual

Convert a geometry into well known text format.

This method relates to the SFCOM IWks::ExportToWKT() method.

This method is the same as the C function OGR_G_ExportToWkt().

Parameters

  ppszDstText | a text buffer is allocated by the program, and assigned to the passed pointer. After use, *ppszDstText should be freed with OGRFree().
  eWkbVariant | the specification that must be conformed too : wbkVariantOgc for old-style 99-402 extended dimension (Z) WKB types wbkVariantIso for SFSQL 1.2 and ISO SQL/MM Part 3

Returns
  Currently OGRERR_NONE is always returned.

Implements OGRGeometry.

Reimplemented in OGRCircularString.

void OGRSimpleCurve::flattenTo2D | ( |  | ) |
| virtual

Convert geometry to strictly 2D.

In a sense this converts all Z coordinates to 0.0.

This method is the same as the C function OGR_G_FlattenTo2D().

Implements OGRGeometry.

double OGRSimpleCurve::get_Length | ( |  | ) | const
| virtual

Returns the length of the curve.

This method relates to the SFCOM ICurve::get_Length() method.

Returns
  the length of the curve, zero if the curve hasn't been initialized.

Implements OGRCurve.

Reimplemented in OGRCircularString.

double OGRSimpleCurve::get_LinearArea | ( |  | ) | const
| protectedvirtual

Compute area of ring / closed linestring.

The area is computed according to Green's Theorem:

Area is "Sum(x(i)*(y(i+1) - y(i-1)))/2" for i = 0 to pointCount-1, assuming the last point is a duplicate of the first.

Returns
  computed area.

void OGRSimpleCurve::getEnvelope | ( | OGREnvelope * | psEnvelope | ) | const
| virtual

Computes and returns the bounding envelope for this geometry in the passed psEnvelope structure.

This method is the same as the C function OGR_G_GetEnvelope().

Parameters

  psEnvelope | the structure in which to place the results.

Implements OGRGeometry.

Reimplemented in OGRCircularString.

void OGRSimpleCurve::getEnvelope | ( | OGREnvelope3D * | psEnvelope | ) | const
| virtual

Computes and returns the bounding envelope (3D) for this geometry in the passed psEnvelope structure.

This method is the same as the C function OGR_G_GetEnvelope3D().

Parameters

  psEnvelope | the structure in which to place the results.

Since
  OGR 1.9.0

Implements OGRGeometry.

Reimplemented in OGRCircularString.

double OGRSimpleCurve::getM | ( | int | iVertex | ) | const

Get measure at vertex.

Returns the M (measure) value at the indicated vertex. If no M value is available, 0.0 is returned. If iVertex is out of range a crash may occur, no internal range checking is performed.

Parameters

  iVertex | the vertex to return, between 0 and getNumPoints()-1.

Returns
  M value.

int OGRSimpleCurve::getNumPoints | ( |  | ) | const
| inlinevirtual

Fetch vertex count.

Returns the number of vertices in the line string.

Returns
  vertex count.

Implements OGRCurve.

void OGRSimpleCurve::getPoint | ( | int | i,
|  | OGRPoint * | poPoint
| ) |  | const

Fetch a point in line string.

This method relates to the SFCOM ILineString::get_Point() method.

Parameters

  i | the vertex to fetch, from 0 to getNumPoints()-1.
  poPoint | a point to initialize with the fetched point.

OGRPointIterator * OGRSimpleCurve::getPointIterator | ( |  | ) | const
| virtual

Returns a point iterator over the curve.

The curve must not be modified while an iterator exists on it.

The iterator must be destroyed with OGRPointIterator::destroy().

Returns
  a point iterator over the curve.

Since
  GDAL 2.0

Implements OGRCurve.

void OGRSimpleCurve::getPoints | ( | OGRRawPoint * | paoPointsOut,
|  | double * | padfZOut = `NULL`
| ) |  | const

Returns all points of line string.

This method copies all points into user list. This list must be at least sizeof(OGRRawPoint) * OGRGeometry::getNumPoints() byte in size. It also copies all Z coordinates.

There is no SFCOM analog to this method.

Parameters

  paoPointsOut | a buffer into which the points is written.
  padfZOut | the Z values that go with the points (optional, may be NULL).

void OGRSimpleCurve::getPoints | ( | void * | pabyX,
|  | int | nXStride,
|  | void * | pabyY,
|  | int | nYStride,
|  | void * | pabyZ = `NULL`,
|  | int | nZStride = `0`
| ) |  | const

Returns all points of line string.

This method copies all points into user arrays. The user provides the stride between 2 consecutive elements of the array.

On some CPU architectures, care must be taken so that the arrays are properly aligned.

There is no SFCOM analog to this method.

Parameters

  pabyX | a buffer of at least (sizeof(double) * nXStride * nPointCount) bytes, may be NULL.
  nXStride | the number of bytes between 2 elements of pabyX.
  pabyY | a buffer of at least (sizeof(double) * nYStride * nPointCount) bytes, may be NULL.
  nYStride | the number of bytes between 2 elements of pabyY.
  pabyZ | a buffer of at last size (sizeof(double) * nZStride * nPointCount) bytes, may be NULL.
  nZStride | the number of bytes between 2 elements of pabyZ.

Since
  OGR 1.9.0

OGRLineString * OGRSimpleCurve::getSubLine | ( | double | dfDistanceFrom,
|  | double | dfDistanceTo,
|  | int | bAsRatio
| ) |  | const
| virtual

Get the portion of linestring.

The portion of the linestring extracted to new one. The input distances (maybe present as ratio of length of linestring) set begin and end of extracted portion.

Parameters

  dfDistanceFrom | The distance from the origin of linestring, where the subline should begins
  dfDistanceTo | The distance from the origin of linestring, where the subline should ends
  bAsRatio | The flag indicating that distances are the ratio of the linestring length.

Returns
  a newly allocated linestring now owned by the caller, or NULL on failure.

Since
  OGR 1.11.0

double OGRSimpleCurve::getX | ( | int | iVertex | ) | const
| inline

Get X at vertex.

Returns the X value at the indicated vertex. If iVertex is out of range a crash may occur, no internal range checking is performed.

Parameters

  iVertex | the vertex to return, between 0 and getNumPoints()-1.

Returns
  X value.

double OGRSimpleCurve::getY | ( | int | iVertex | ) | const
| inline

Get Y at vertex.

Returns the Y value at the indicated vertex. If iVertex is out of range a crash may occur, no internal range checking is performed.

Parameters

  iVertex | the vertex to return, between 0 and getNumPoints()-1.

Returns
  X value.

double OGRSimpleCurve::getZ | ( | int | iVertex | ) | const

Get Z at vertex.

Returns the Z (elevation) value at the indicated vertex. If no Z value is available, 0.0 is returned. If iVertex is out of range a crash may occur, no internal range checking is performed.

Parameters

  iVertex | the vertex to return, between 0 and getNumPoints()-1.

Returns
  Z value.

OGRErr OGRSimpleCurve::importFromWkb | ( | unsigned char * | pabyData,
|  | int | nSize = `-1`,
|  | OGRwkbVariant | eWkbVariant = `wkbVariantOldOgc`
| ) |  |
| virtual

Assign geometry from well known binary data.

The object must have already been instantiated as the correct derived type of geometry object to match the binaries type. This method is used by the OGRGeometryFactory class, but not normally called by application code.

This method relates to the SFCOM IWks::ImportFromWKB() method.

This method is the same as the C function OGR_G_ImportFromWkb().

Parameters

  pabyData | the binary input data.
  nSize | the size of pabyData in bytes, or zero if not known.
  eWkbVariant | if wkbVariantPostGIS1, special interpretation is done for curve geometries code

Returns
  OGRERR_NONE if all goes well, otherwise any of OGRERR_NOT_ENOUGH_DATA, OGRERR_UNSUPPORTED_GEOMETRY_TYPE, or OGRERR_CORRUPT_DATA may be returned.

Implements OGRGeometry.

Reimplemented in OGRCircularString, and OGRLinearRing.

OGRErr OGRSimpleCurve::importFromWkt | ( | char ** | ppszInput | ) |
| virtual

Assign geometry from well known text data.

The object must have already been instantiated as the correct derived type of geometry object to match the text type. This method is used by the OGRGeometryFactory class, but not normally called by application code.

This method relates to the SFCOM IWks::ImportFromWKT() method.

This method is the same as the C function OGR_G_ImportFromWkt().

Parameters

  ppszInput | pointer to a pointer to the source text. The pointer is updated to pointer after the consumed text.

Returns
  OGRERR_NONE if all goes well, otherwise any of OGRERR_NOT_ENOUGH_DATA, OGRERR_UNSUPPORTED_GEOMETRY_TYPE, or OGRERR_CORRUPT_DATA may be returned.

Implements OGRGeometry.

Reimplemented in OGRCircularString.

OGRBoolean OGRSimpleCurve::IsEmpty | ( |  | ) | const
| virtual

Returns TRUE (non-zero) if the object has no points.

Normally this returns FALSE except between when an object is instantiated and points have been assigned.

This method relates to the SFCOM IGeometry::IsEmpty() method.

Returns
  TRUE if object is empty, otherwise FALSE.

Reimplemented from OGRGeometry.

OGRSimpleCurve & OGRSimpleCurve::operator= | ( | const OGRSimpleCurve & | other | ) |

Assignment operator.

Note: before GDAL 2.1, only the default implementation of the operator existed, which could be unsafe to use.

Since
  GDAL 2.1

double OGRSimpleCurve::Project | ( | const OGRPoint * |  | ) | const
| virtual

Project point on linestring.

The input point projected on linestring. This is the shortest distance from point to the linestring. The distance from begin of linestring to the point projection returned.

This method is built on the GEOS library (GEOS >= 3.2.0), check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always return -1, issuing a CPLE_NotSupported error.

Returns
  a distance from the begin of the linestring to the projected point.

Since
  OGR 1.11.0

void OGRSimpleCurve::reversePoints | ( | void |  | ) |

Reverse point order.

This method updates the points in this line string in place reversing the point ordering (first for last, etc).

void OGRSimpleCurve::segmentize | ( | double | dfMaxLength | ) |
| virtual

Modify the geometry such it has no segment longer then the given distance.

Add intermediate vertices to a geometry.

Interpolated points will have Z and M values (if needed) set to 0. Distance computation is performed in 2d only

This function is the same as the C function OGR_G_Segmentize()

Parameters

  dfMaxLength | the maximum distance between 2 points after segmentization

This method modifies the geometry to add intermediate vertices if necessary so that the maximum length between 2 consecutive vertices is lower than dfMaxLength.

Parameters

  dfMaxLength | maximum length between 2 consecutive vertices.

Reimplemented from OGRGeometry.

Reimplemented in OGRCircularString.

void OGRSimpleCurve::set3D | ( | OGRBoolean | bIs3D | ) |
| virtual

Add or remove the Z coordinate dimension.

This method adds or removes the explicit Z coordinate dimension. Removing the Z coordinate dimension of a geometry will remove any existing Z values. Adding the Z dimension to a geometry collection, a compound curve, a polygon, etc. will affect the children geometries.

Parameters

  bIs3D | Should the geometry have a Z dimension, either TRUE or FALSE.

Since
  GDAL 2.1

Reimplemented from OGRGeometry.

void OGRSimpleCurve::setCoordinateDimension | ( | int | nNewDimension | ) |
| virtual

Set the coordinate dimension.

This method sets the explicit coordinate dimension. Setting the coordinate dimension of a geometry to 2 should zero out any existing Z values. Setting the dimension of a geometry collection, a compound curve, a polygon, etc. will affect the children geometries. This will also remove the M dimension if present before this call.

Deprecated:
  use set3D() or setMeasured().

Parameters

  nNewDimension | New coordinate dimension value, either 2 or 3.

Reimplemented from OGRGeometry.

void OGRSimpleCurve::setMeasured | ( | OGRBoolean | bIsMeasured | ) |
| virtual

Add or remove the M coordinate dimension.

This method adds or removes the explicit M coordinate dimension. Removing the M coordinate dimension of a geometry will remove any existing M values. Adding the M dimension to a geometry collection, a compound curve, a polygon, etc. will affect the children geometries.

Parameters

  bIsMeasured | Should the geometry have a M dimension, either TRUE or FALSE.

Since
  GDAL 2.1

Reimplemented from OGRGeometry.

void OGRSimpleCurve::setNumPoints | ( | int | nNewPointCount,
|  | int | bZeroizeNewContent = `TRUE`
| ) |  |

Set number of points in geometry.

This method primary exists to preset the number of points in a linestring geometry before setPoint() is used to assign them to avoid reallocating the array larger with each call to addPoint().

This method has no SFCOM analog.

Parameters

  nNewPointCount | the new number of points for geometry.
  bZeroizeNewContent | whether to set to zero the new elements of arrays that are extended.

void OGRSimpleCurve::setPoint | ( | int | iPoint,
|  | OGRPoint * | poPoint
| ) |  |

Set the location of a vertex in line string.

If iPoint is larger than the number of necessary the number of existing points in the line string, the point count will be increased to accommodate the request.

There is no SFCOM analog to this method.

Parameters

  iPoint | the index of the vertex to assign (zero based).
  poPoint | the value to assign to the vertex.

void OGRSimpleCurve::setPoint | ( | int | iPoint,
|  | double | xIn,
|  | double | yIn,
|  | double | zIn
| ) |  |

Set the location of a vertex in line string.

If iPoint is larger than the number of necessary the number of existing points in the line string, the point count will be increased to accommodate the request.

There is no SFCOM analog to this method.

Parameters

  iPoint | the index of the vertex to assign (zero based).
  xIn | input X coordinate to assign.
  yIn | input Y coordinate to assign.
  zIn | input Z coordinate to assign (defaults to zero).

void OGRSimpleCurve::setPoints | ( | int | nPointsIn,
|  | OGRRawPoint * | paoPointsIn,
|  | double * | padfZIn = `NULL`
| ) |  |

Assign all points in a line string.

This method clears any existing points assigned to this line string, and assigns a whole new set. It is the most efficient way of assigning the value of a line string.

There is no SFCOM analog to this method.

Parameters

  nPointsIn | number of points being passed in paoPointsIn
  paoPointsIn | list of points being assigned.
  padfZ | the Z values that go with the points (optional, may be NULL).

void OGRSimpleCurve::setPoints | ( | int | nPointsIn,
|  | OGRRawPoint * | paoPointsIn,
|  | double * | padfZIn,
|  | double * | padfMIn
| ) |  |

Assign all points in a line string.

This method clears any existing points assigned to this line string, and assigns a whole new set. It is the most efficient way of assigning the value of a line string.

There is no SFCOM analog to this method.

Parameters

  nPointsIn | number of points being passed in paoPointsIn
  paoPointsIn | list of points being assigned.
  padfZ | the Z values that go with the points.
  padfM | the M values that go with the points.

void OGRSimpleCurve::setPoints | ( | int | nPointsIn,
|  | double * | padfX,
|  | double * | padfY,
|  | double * | padfZIn = `NULL`
| ) |  |

Assign all points in a line string.

This method clear any existing points assigned to this line string, and assigns a whole new set.

There is no SFCOM analog to this method.

Parameters

  nPointsIn | number of points being passed in padfX and padfY.
  padfX | list of X coordinates of points being assigned.
  padfY | list of Y coordinates of points being assigned.
  padfZ | list of Z coordinates of points being assigned (defaults to NULL for 2D objects).

void OGRSimpleCurve::setPoints | ( | int | nPointsIn,
|  | double * | padfX,
|  | double * | padfY,
|  | double * | padfZIn,
|  | double * | padfMIn
| ) |  |

Assign all points in a line string.

This method clear any existing points assigned to this line string, and assigns a whole new set.

There is no SFCOM analog to this method.

Parameters

  nPointsIn | number of points being passed in padfX and padfY.
  padfX | list of X coordinates of points being assigned.
  padfY | list of Y coordinates of points being assigned.
  padfZ | list of Z coordinates of points being assigned.
  padfM | list of M coordinates of points being assigned.

void OGRSimpleCurve::setPointsM | ( | int | nPointsIn,
|  | OGRRawPoint * | paoPointsIn,
|  | double * | padfMIn
| ) |  |

Assign all points in a line string.

This method clears any existing points assigned to this line string, and assigns a whole new set. It is the most efficient way of assigning the value of a line string.

There is no SFCOM analog to this method.

Parameters

  nPointsIn | number of points being passed in paoPointsIn
  paoPointsIn | list of points being assigned.
  padfM | the M values that go with the points.

void OGRSimpleCurve::setPointsM | ( | int | nPointsIn,
|  | double * | padfX,
|  | double * | padfY,
|  | double * | padfMIn = `NULL`
| ) |  |

Assign all points in a line string.

This method clear any existing points assigned to this line string, and assigns a whole new set.

There is no SFCOM analog to this method.

Parameters

  nPointsIn | number of points being passed in padfX and padfY.
  padfX | list of X coordinates of points being assigned.
  padfY | list of Y coordinates of points being assigned.
  padfM | list of M coordinates of points being assigned.

void OGRSimpleCurve::StartPoint | ( | OGRPoint * | poPoint | ) | const
| virtual

Return the curve start point.

This method relates to the SF COM ICurve::get_StartPoint() method.

Parameters

  poPoint | the point to be assigned the start location.

Implements OGRCurve.

void OGRSimpleCurve::swapXY | ( |  | ) |
| virtual

Swap x and y coordinates.

Since
  OGR 1.8.0

Reimplemented from OGRGeometry.

OGRErr OGRSimpleCurve::transform | ( | OGRCoordinateTransformation * | poCT | ) |
| virtual

Apply arbitrary coordinate transformation to geometry.

This method will transform the coordinates of a geometry from their current spatial reference system to a new target spatial reference system. Normally this means reprojecting the vectors, but it could include datum shifts, and changes of units.

Note that this method does not require that the geometry already have a spatial reference system. It will be assumed that they can be treated as having the source spatial reference system of the OGRCoordinateTransformation object, and the actual SRS of the geometry will be ignored. On successful completion the output OGRSpatialReference of the OGRCoordinateTransformation will be assigned to the geometry.

This method is the same as the C function OGR_G_Transform().

Parameters

  poCT | the transformation to apply.

Returns
  OGRERR_NONE on success or an error code.

Implements OGRGeometry.

void OGRSimpleCurve::Value | ( | double | dfDistance,
|  | OGRPoint * | poPoint
| ) |  | const
| virtual

Fetch point at given distance along curve.

This method relates to the SF COM ICurve::get_Value() method.

This function is the same as the C function OGR_G_Value().

Parameters

  dfDistance | distance along the curve at which to sample position. This distance should be between zero and get_Length() for this curve.
  poPoint | the point to be assigned the curve position.

Implements OGRCurve.

Reimplemented in OGRCircularString.

int OGRSimpleCurve::WkbSize | ( |  | ) | const
| virtual

Returns size of related binary representation.

This method returns the exact number of bytes required to hold the well known binary representation of this geometry object. Its computation may be slightly expensive for complex geometries.

This method relates to the SFCOM IWks::WkbSize() method.

This method is the same as the C function OGR_G_WkbSize().

Returns
  size of binary representation in bytes.

Implements OGRGeometry.

Reimplemented in OGRLinearRing.

The documentation for this class was generated from the following files:

- ogr_geometry.h
- ogrlinestring.cpp

Generated for GDAL by 1.8.8.